#Create a SQS endpoint.
class AWSSQS
  #Params
  # buffer_size => number of messages to send per call to SQS

  def initialize(buffer_size=SettingsProvider::MAX_BUFFER_SIZE)
    @buffer  = []
    @buffer_size = buffer_size > SettingsProvider::MAX_BUFFER_SIZE ? SettingsProvider::MAX_BUFFER_SIZE : buffer_size

    credentials = SettingsProvider.get_credentials

    @client = AWS::SQS.new(
      :access_key_id => credentials['access_key'],
      :secret_access_key => credentials['secret_key']
    )

    @queue = @client.queues.entries.first
  end

  #Adds a message to this endpoint
  

  def add_message(message)
    begin
      @buffer <<  message
      if (@buffer.size >= @buffer_size)
        @queue.batch_send(*@buffer)
        @buffer.clear
      end
    rescue AWS::SQS::Errors::BatchSendError => exception
      DaemonSpawn::Base.log_file << "Could not send the message(s)"
      DaemonSpawn::Base.log_file << exception.failures
    end  
  end
end
